<?php
if(!defined('VALID_CMS_ADMIN')) { die('ACCESS DENIED'); }

cmsCore::loadClass('regban');
$regban = new cmsRegBan();
$opt = cmsCore::request('opt', 'str', 'list_items');
$toolmenu = array();

if ($opt=='list_items'){
    $toolmenu[] = array('icon'=>'newstuff.gif', 'title'=>'Новое значение', 'link'=>'?view=components&do=config&id='.$id.'&opt=add_item');
} else {
    $toolmenu[] = array('icon'=>'save.gif', 'title'=>$_LANG['SAVE'], 'link'=>'javascript:document.addform.submit();');
}

cpToolMenu($toolmenu);

if ($opt == 'submit_item' || $opt == 'update_item'){

    if (!cmsUser::checkCsrfToken()) { cmsCore::error404(); }
    $errors = false;
    $item_id = cmsCore::request('item_id', 'int', 0);

    $item['value']          = cmsCore::request('value', 'str', '');
    $item['type']           = cmsCore::request('type', 'str', '');
    if(!$item['value']) {
        cmsCore::addSessionMessage('Значение не указано', 'error');
        if($opt == 'submit_item') {
            cmsCore::redirect('?view=components&do=config&id='.$id.'&opt=add_item');
        } else {
            $item_id = cmsCore::request('item_id', 'int', 0);
            cmsCore::redirect('?view=components&do=config&id='.$id.'&opt=edit_item&item_id='.$item_id);
        }
        
    }
    
    if ($opt == 'submit_item'){
        $item_id = $regban->addItem($item);
    } else {
        $regban->updateItem($item_id, $item);
    }

    cmsCore::addSessionMessage($_LANG['AD_DO_SUCCESS'], 'success');
    cmsCore::redirect('?view=components&do=config&id='.$id.'');

}

//=================================================================================================//
//=================================================================================================//

if($opt == 'delete_item'){
    
    $regban->deleteItem(cmsCore::request('item_id', 'int', 0));
    cmsCore::addSessionMessage($_LANG['AD_DO_SUCCESS'], 'success');
    cmsCore::redirect('?view=components&do=config&id='.$id.'&opt=list_items');
    
}

//=================================================================================================//
//=================================================================================================//

if ($opt == 'list_items'){

    echo '<h3>Список</h3>';

    $fields[] = array('title'=>'id', 'field'=>'id', 'width'=>'30');
    $fields[] = array('title'=>'Значение', 'field'=>'value', 'width'=>'0', 'link'=>'?view=components&do=config&id='.$id.'&opt=edit_item&item_id=%id%');
    $fields[] = array('title'=>'Тип', 'field'=>'type', 'width'=>'0', 'link'=>'?view=components&do=config&id='.$id.'&opt=edit_item&item_id=%id%');
    
    $actions[] = array('title'=>$_LANG['EDIT'], 'icon'=>'edit.gif', 'link'=>'?view=components&do=config&id='.$id.'&opt=edit_item&item_id=%id%');
    $actions[] = array('title'=>$_LANG['DELETE'], 'icon'=>'delete.gif', 'confirm'=>'Удалить', 'link'=>'?view=components&do=config&id='.$id.'&opt=delete_item&item_id=%id%');

    echo '<script type="text/javascript">function openCat(id){ $("#catform input").val(id); $("#catform").submit(); } </script>';
    echo '<form id="catform" method="post" action="index.php?view=components&do=config&id='.$id.'&opt=list_items"></form>';

    cpListTable('cms_regbanlist', $fields, $actions, '', '');

}
//=================================================================================================//
//=================================================================================================//

if ($opt == 'add_item' || $opt == 'edit_item'){

    require('../includes/jwtabs.php');
    $GLOBALS['cp_page_head'][] = jwHeader();

    if ($opt=='add_item'){
        $title = 'Новая запись';
        echo '<h3>'.$title.'</h3>';
    } else {
        $item_id = cmsCore::request('item_id', 'int', 0);
        $mod = $regban->getItem($item_id);
        if(!$mod){ cmsCore::error404(); }
        $title = 'Редактировать запись';
        echo '<h3>'.$title.'</h3>';
    } ?>

    <form id="addform" name="addform" method="post" action="index.php?view=components&do=config&id=<?php echo $id;?>" enctype="multipart/form-data">
    <input type="hidden" name="csrf_token" value="<?php echo cmsUser::getCsrfToken(); ?>" />
    <table class="proptable" width="100%" cellpadding="15" cellspacing="2">
        <tr>
            <!-- главная ячейка -->
            <td valign="top">
                <div><strong>Значение</strong></div>
                <div><input name="value" type="text" id="value" style="width:99%" autocomplete="off" value="<?php if(isset($mod['value'])) {echo htmlspecialchars($mod['value']);}?>" /></div>
                <div style="margin-top:10px"></div>
                <div><span class="hinttext">
                    Можно использовать маску: NNN.NNN.NNN.*, NNN.NNN.*, NNN.*, *@mail.zone,*.zone
                </span></div>

                <div style="margin-top:10px"><strong>Тип</strong></div>
                <div>
                    <select name="type" id="type" style="width:100%">
                        <option value="ip" <?php if (isset($mod['type']) && $mod['type'] == 'ip') { echo 'selected="selected"'; } ?>>IP</option>
                        <option value="email" <?php if (isset($mod['type']) && $mod['type'] == 'email') { echo 'selected="selected"'; } ?>>Email</option>
                    </select>
                </div>
            </td>
        </tr>
    </table>
    <p>
        <input name="add_mod" type="submit" id="add_mod" value="<?php echo $_LANG['SAVE']; ?>" />
        <input name="back" type="button" id="back" value="<?php echo $_LANG['CANCEL'];?>" onclick="window.history.back();"/>
        <input name="opt" type="hidden" id="opt" <?php if ($opt=='add_item') { echo 'value="submit_item"'; } else { echo 'value="update_item"'; } ?> />
        <?php
            if ($opt=='edit_item'){
                echo '<input name="item_id" type="hidden" value="'.$mod['id'].'" />';
            }
        ?>
    </p>
    </form>

 <?php
}