<?php

    class p_simplacaptcha extends cmsPlugin
    {

        public function __construct()
        {

            parent::__construct();

            // Информация о плагине
            $this->info['plugin']      = 'p_simplacaptcha';
            $this->info['title']       = 'Капча Simpla';
            $this->info['description'] = 'Выводит капчу в форме.';
            $this->info['author']      = '<a href="http://themeinstant.ru">themeInstant</a>';
            $this->info['version']     = '1.10.5';

            // События, которые будут отлавливаться плагином
            $this->events[] = 'GET_CAPTCHA';
            $this->events[] = 'CHECK_CAPTCHA';

        }

        /**
         * Процедура установки плагина
         * @return bool
         */
        public function install()
        {
            return parent::install();
        }

        /**
         * Процедура обновления плагина
         * @return bool
         */
        public function upgrade()
        {
            return parent::upgrade();
        }


        /**
         * Обработка событий
         * @param string $event
         * @param mixed $item
         * @return html
         */

        public function execute($event = '', $item = array())
        {
            global $_LANG;

            parent::execute($event, $item);

            //if (!$item['input_name']) {
            //    return $item;
            //}

            switch ($event){
                case 'GET_CAPTCHA':   return $this->getCaptcha();
                case 'CHECK_CAPTCHA': return $this->checkCaptcha();
            }

            return $item;



        }

        public function getCaptcha()
        {
            global $_LANG;

            cmsPage::getInstance()->addHeadCSS('plugins/p_simplacaptcha/css/simplacaptcha.css');
            cmsPage::getInstance()->addHeadJS('plugins/p_simplacaptcha/js/simplacaptcha-init.js');

            $captcha = cmsPage::initTemplate('plugins', 'p_simplacaptcha.tpl')
                ->assign('input_id', substr(uniqid(), 0, 10))
                ->assign('input_name', $item['input_name'])
                ->assign('LANG', $_LANG)
                ->fetch('p_simplacaptcha.tpl');

            if (!$captcha) {
                return $item;
            }

            return $captcha;
        }


        public function checkCaptcha() {

            $captcha_code = cmsCore::request('code', 'str', '');
            $captcha_id   = cmsCore::request('captcha_id', 'str', '');

            if(!$captcha_id || empty($_SESSION['captcha'][$captcha_id]) || !$captcha_code) { return false; }

            $real_code = $_SESSION['captcha'][$captcha_id];
            unset($_SESSION['captcha'][$captcha_id]);

            return ($real_code === $captcha_code);

        }

    }
