{add_js file='components/shop/js/cart.js'}

{if $cfg.ratings}
    {add_js file='components/shop/js/rating/jquery.MetaData.js'}
    {add_js file='components/shop/js/rating/jquery.rating.js'}
    {add_css file='components/shop/js/rating/jquery.rating.css'}
    <div class="float_bar">
        <form action="/shop/rate" method="POST">
            <input type="hidden" name="item_id" value="{$item.id}" />
            <input type="hidden" name="points" value="{$item.id}" />
            {section name=rate start=1 loop=6 step=1}
                <input name="rate" type="radio" class="star" value="{$smarty.section.rate.index}" {if $item.rating>=$smarty.section.rate.index}checked="checked"{/if} {if !$is_user || $item.user_voted}disabled="disabled"{/if} />
            {/section}
        </form>
        {if $item.rating}
            <small>{$item.rating} / <span style="color:gray">{$item.rating_votes|spellcount:$LANG.SHOP_VOTES:$LANG.SHOP_VOTES2:$LANG.SHOP_VOTES10}</span></small>
        {/if}
    </div>
{/if}
<h1 class="con_heading">
    {if $cfg.show_hit_img && $item.is_hit} <span class="glyphicon glyphicon-bookmark text-danger"></span>{/if}
    {$item.title}
</h1>
<div class="row margin-bottom-row">
	<div class="col-md-4">
        <div class="media-gird">
            <img src="/images/photos/medium/{$item.filename}" class="media-object" />
        </div>
        {if $item.images}
			<div class="additional-gird">
				<ul class="additional-gird-list">
            {foreach key=num item=file from=$item.images}
					<li>
						<a href="/images/photos/medium/{$file}" class="lightbox-enabled" rel="lightbox-galery" title="{$item.title|escape:'html'} ({$LANG.SHOP_PHOTO} {$num+1})"><img src="/images/photos/small/{$file}" class="media-object" /></a>
					</li>			
            {/foreach}
				</ul>
            </div>
        {/if}	
{if $nav}
    <div class="panel panel-default" style="margin-top:15px;">
		<div class="panel-heading">
			<h3 class="panel-title">{$LANG.SHOP_ITEMS_NAV}:</h3>
		</div>
        <div class="list-group">
            {if $nav.prev}
                <a class="list-group-item" href="/shop/{$nav.prev.seolink}.html">&larr; {$nav.prev.title}</a>
            {/if}
            {if $nav.prev && $nav.next} | {/if}
            {if $nav.next}
                <a class="list-group-item" href="/shop/{$nav.next.seolink}.html">{$nav.next.title} &rarr;</a>
            {/if}
        </div>
    </div>
{/if}			
	</div>
	<div class="col-md-8">
                {if $cfg.show_full_desc}
                    <div class="item-description">{$item.description}</div>
                {/if}
               <form action="/shop/addtocart" method="POST">
                {if $cfg.is_shop && !$item.hide_price}
                                {if !$cfg.track_qty || $item.qty>0}

                                        <input type="hidden" name="add_to_cart_item_id" value="{$item.id}" />
                                        <table cellpadding="0" cellspacing="0" border="0" height="34" class="price_table">
                                            <tr>
                                                {if $item.old_price > 0}
                                                    <td style="padding-right:3px">
                                                        <div class="old_price bg-danger"><em>{$item.old_price}</em></div>
                                                    </td>
                                                    <td width="16" style="padding-right:0px;color:#dedede;">
                                                        <span class="glyphicon glyphicon-chevron-right"></span>
                                                    </td>
                                                {/if}
                                                {if !$item.vars}
                                                    <td>
                                                        <div class="new_price bg-success"><em>{$item.price} {$cfg.currency}</em></div>
                                                        <input type="hidden" name="var_art_no" value="" />
                                                    </td>
                                                {else}
                                                    <td>
                                                        <select name="var_art_no" class="var_art_no" style="max-width:250px;">
                                                            {foreach key=num item=var from=$item.vars}
                                                                {if $var.qty>0}
                                                                    <option value="{$var.art_no}">{$var.title} &mdash; {$var.price} {$cfg.currency}</option>
                                                                {/if}
                                                            {/foreach}
                                                        </select>
                                                    </td>
                                                {/if}
                                                <td>
                                                    <div id="add_to_cart_{$item.id}">
                                                        {if $cfg.qty_mode != 'one'}
                                                            <div class="qty" style="display:none">
                                                                <table cellpadding="0" cellspacing="0" border="0">
                                                                    <tr>
                                                                        <td>X</td>
                                                                        <td>
                                                                            {if $cfg.qty_mode=='qty'}
                                                                                {if $item.qty}
                                                                                    <select name="qty" style="width:40px !important">
                                                                                        {section name=qty loop=$item.qty step=1}
                                                                                          <option value="{$smarty.section.qty.index+1}" {if $smarty.section.qty.index+1 == $item.cart_qty}selected="selected"{/if}>{$smarty.section.qty.index+1}</option>
                                                                                        {/section}
                                                                                    </select>
                                                                                {/if}
                                                                            {/if}
                                                                            {if $cfg.qty_mode=='any'}
                                                                                <input name="qty" style="width:40px !important;text-align:center" class="form-control" value="1" />
                                                                            {/if}
                                                                        </td>
                                                                        <td><input type="submit" class="bnt btn-primary" value="&rarr;" /></td>
                                                                    </tr>
                                                                </table>
                                                            </div>
                                                            <input type="button" onclick="addToCart({$item.id})" class="add" name="addtocart" value="{$LANG.SHOP_ADD_TO_CART}" />
                                                        {else}
                                                            <input type="submit" class="add" name="addtocart" value="{$LANG.SHOP_ADD_TO_CART}" />
                                                        {/if}
                                                    </div>
                                                </td>
                                            </tr>
                                        </table>

                                {else}
                                    <div class="old_price"><span style="text-decoration:none;color:#666">Нет в наличии</span></div>
                                {/if}
								<br />
                {/if}			   
				<ul class="list-group">
                {if $cfg.show_cats}
                    <li class="list-group-item">
                        <span class="quest">{$LANG.SHOP_ITEM_CATS}:</span> <span class="answer">
                        {foreach key=num item=cat from=$item.cats}
                            <a href="/shop/{$item.cats_data[$num].seolink}">{$item.cats_data[$num].title}</a>{if $num<sizeof($item.cats)-1}, {/if}
                        {/foreach}</span>
                    </li>
                {/if}
                {if $cfg.show_vendors && $item.vendor}
                    <li class="list-group-item">
                        <span class="quest">{$LANG.SHOP_ITEM_VENDOR}:</span> <span class="answer"><a href="/shop/vendors/{$item.vendor_id}">{$item.vendor}</a></span>
                    </li>
                {/if}				
                {if $item.chars}
                    {assign var=last_grp value=""}
                    
                        {foreach key=num item=char from=$item.chars}
                            {if $cfg.show_char_grp}
                                {if $char.fieldgroup && ($char.fieldgroup!=$last_grp)}
                                    <li class="list-group-item list-group-title">{$char.fieldgroup}</li>
                                {/if}
                                {assign var=last_grp value=$char.fieldgroup}
                            {/if}

                            {if $char.value}
                                {if !$char.is_custom}
                                    <li class="list-group-item">
                                        <span class="quest">{$char.title}:</span>
                                        <span class="answer">{"|"|str_replace:', ':$char.value} {if $char.units}{$char.units}{/if}</span>
                                    </li>
                                {else}
                                    <li class="list-group-item">
                                            <select name="chars[{$char.id}]">
                                                {foreach key=c item=val from=$char.items}
                                                    <option value="{$val}">{$char.title}: {$val}</option>
                                                {/foreach}
                                            </select>
                                    </li>
                                {/if}
                            {/if}

                        {/foreach}
                {/if}
				</ul>
                </form>
			
		        {if $item.tagline}
                    <div class="media-hinttext">
                        {$item.tagline}
                    </div>
                {/if}		
	</div>
</div>



{if $cfg.show_related && $related_items}
    <div class="panel panel-default">
		<div class="panel-heading">
			<h3 class="panel-title">{$LANG.SHOP_RELATED}:</h3>
		</div>
		<div class="panel-body">
        <div class="row margin-bottom-row">
            {foreach key=rid item=rel from=$related_items}
                <div class="col-md-3 col-sm-6 media-gird">
                        <a href="/shop/{$rel.seolink}.html">
                            <img src="/images/photos/small/{$rel.filename}" class="media-object" title="{$rel.title}"/>
                        </a>
                        <a href="/shop/{$rel.seolink}.html" class="monospc">{$rel.title}</a>
                </div>
            {/foreach}
        </div>
		</div>
    </div>
{/if}

<script type="text/javascript">

    {if $cfg.ratings}
        {literal}
            $('.star').rating({
                callback: function(value, link){
                    $(this.form).find('input[name=points]').val(value);
                    this.form.submit();
                }
            });
        {/literal}
    {/if}

</script>